VERSION 2.00
Begin Form AppOpenSave 
   BorderStyle     =   3  'Fixed Double
   Caption         =   "File Open"
   ClientHeight    =   3150
   ClientLeft      =   1080
   ClientTop       =   2895
   ClientWidth     =   4980
   Height          =   3555
   Icon            =   APPOPSV.FRX:0000
   Left            =   1020
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3150
   ScaleWidth      =   4980
   Top             =   2550
   Width           =   5100
   Begin ListBox DirectoriesList 
      Height          =   1785
      Left            =   1950
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   1170
      Width           =   1575
   End
   Begin FileListBox FilesList 
      Height          =   1785
      Left            =   165
      TabIndex        =   3
      Top             =   1170
      Width           =   1575
   End
   Begin CommandButton CancelCmd 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3705
      TabIndex        =   7
      Top             =   615
      Width           =   1095
   End
   Begin CommandButton OKCmd 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   3705
      TabIndex        =   6
      Top             =   135
      Width           =   1095
   End
   Begin TextBox FileName 
      Height          =   315
      Left            =   1140
      TabIndex        =   5
      Text            =   "FileName"
      Top             =   165
      Width           =   2400
   End
   Begin Label DirectoriesLbl 
      Caption         =   "&Directories:"
      Height          =   195
      Left            =   1950
      TabIndex        =   0
      Top             =   900
      Width           =   1035
   End
   Begin Label FilesLbl 
      AutoSize        =   -1  'True
      Caption         =   "&Files:"
      Height          =   195
      Left            =   150
      TabIndex        =   2
      Top             =   915
      Width           =   465
   End
   Begin Label Directory 
      Height          =   255
      Left            =   1155
      TabIndex        =   9
      Top             =   580
      Width           =   2310
   End
   Begin Label DirectoryLbl 
      Caption         =   "Directory:"
      Height          =   255
      Left            =   170
      TabIndex        =   8
      Top             =   580
      Width           =   855
   End
   Begin Label FileNameLbl 
      Caption         =   "File &Name:"
      Height          =   255
      Left            =   170
      TabIndex        =   4
      Top             =   210
      Width           =   975
   End
End
DefInt A-Z
Dim CurFocus        As Integer
Dim UpdateDirList   As Integer
Dim SetFileLimit    As Integer
Dim LastChange      As Integer
Dim SaveDuplicate   As Integer
Dim App_OpenSaveTitle As String

Function BuildSpec (fpath As String) As String
  
  If Right$(fpath, 1) <> "\" Then
    s$ = fpath + "\*.*"
  Else
    s$ = fpath + "*.*"
  End If
  BuildSpec = s$

End Function

Sub CancelCmd_Click ()
  
  App_DialogReturn = IDCANCEL
  AppOpenSave.Hide

End Sub

Function CheckFileQual (fqual As String) As Integer
  
  CheckFileQual = True

  x% = InStr(fqual, ".")
  If x% = 0 Or x% > 9 Or (Len(fqual) - x%) > 3 Then
    CheckFileQual = False
  Else
    If InStr(x% + 1, fqual, ".") <> 0 Then CheckFileQual = False  ' too many .
  End If

  If InStr(fqual, ",") <> 0 Or InStr(fqual, "/") <> 0 Or InStr(fqual, " ") <> 0 Then
    CheckFileQual = False
  End If

End Function

Sub DirectoriesList_Click ()
  
  Dim pqual As String
  Dim fqual As String
  
  a$ = FileName.Text
  SplitFileName a$, pqual, fqual

  If App_OpenSaveStyle = APP_OPEN Then
    If InStr(fqual, "*") = 0 And InStr(fqual, "?") = 0 Then
      temp$ = "*" + App_FileExtension
    Else
      temp$ = fqual
    End If
  Else
    temp$ = ""
  End If

  sel$ = DirectoriesList.Text
  If Mid$(sel$, 2, 1) = "-" Then
    FileName.Text = Mid$(sel$, 3, 1) + ":" + temp$
  Else
    FileName.Text = Mid$(sel$, 2, Len(sel$) - 2) + "\" + temp$
  End If

End Sub

Sub DirectoriesList_Dblclick ()
  
  OKCmd_Click

End Sub

Sub DirectoriesList_GotFocus ()
  
  If UpdateDirList Then
    '
    ' first time load of directories list
    '
    CurFocus = GetFocus()
    x& = SendMessage(CurFocus, LB_DIR, &HC010, ByVal BuildSpec((FilesList.Path)))
    UpdateDirList = False
    FileName.SelStart = 0
    FileName.SelLength = Len(FileName.Text)
    If Visible Then FileName.SetFocus
  End If

End Sub

Sub DirectoriesList_KeyPress (KeyAscii As Integer)
  
  '
  ' check if the user presses the Return key while on a valid entry
  '
  If KeyAscii = 13 Then
    If DirectoriesList.ListIndex > -1 Then
      DirectoriesList_Dblclick
    End If
  End If

End Sub

Sub FileName_Change ()
  
  LastChange = 1
  If FileName.Text = "" Then
    OKCmd.Enabled = False
  Else
    OKCmd.Enabled = True
  End If

End Sub

Sub FileName_GotFocus ()
  
  If SetFileLimit Then
    '
    ' limit the text entry to not more than 127 characters
    '
    i% = 127
    TextLimit& = SendMessage(GetFocus(), EM_LIMITTEXT, i%, ByVal "")
    SetFileLimit = False
  End If

End Sub

Sub FileName_KeyPress (KeyAscii As Integer)
  
  If KeyAscii = 13 Then KeyAscii = 0   ' get rid of the beep

  If KeyAscii = 0 Then
    temp$ = RemoveSpaces((FileName.Text))

    If App_OpenSaveStyle = APP_SAVE Then
      '
      ' do save checking here - add extension if user forgot
      '
      If InStr(temp$, ".") = 0 And Right$(temp$, 1) <> "\" And Right$(temp$, 1) <> ":" Then
	temp$ = temp$ + App_FileExtension
      End If

      If Validate_SaveFileName(temp$, fout$) Then
	App_FileName = fout$
	LastChange = 5
	OKCmd_Click
      End If
    Else
      '
      ' open file checking
      '
      If Validate_OpenFileName(temp$, fout$) Then
	App_FileName = fout$
	LastChange = 5
	OKCmd_Click
      End If
    End If
  End If

End Sub

Sub FilesList_Click ()
  
  If App_OpenSaveStyle = APP_OPEN Then
    a$ = FilesList.FileName
    If InStr(a$, ".") = 0 Then a$ = a$ + "."
    FileName.Text = a$
    LastChange = 2
  End If

End Sub

Sub FilesList_DblClick ()
  
  If App_OpenSaveStyle = APP_OPEN Then
    LastChange = 2
    OKCmd_Click
  Else
    '
    ' duplicate file name on save
    '
    SaveDuplicate = True
    If UCase$(FilesList.FileName) <> UCase$(App_FileName) Then
      x% = MsgBox("Replace Existing " + UCase$(FilesList.FileName) + "?", MB_ICONEXCLAMATION + MB_YESNO + MB_DEFBUTTON2, APP_NAME)
      If x% = IDNO Then
	Debug.Print "do not save the file!"
	SaveDuplicate = False
      End If
    End If
  End If

End Sub

Sub FilesList_KeyPress (KeyAscii As Integer)

  If KeyAscii = 13 Then
    If FilesList.ListIndex > -1 Then FilesList_DblClick
  End If

End Sub

Sub Form_GotFocus ()
  
  If UpdateDirList Then
    FilesList.SetFocus          ' Set the Focus to fill the ListBox
  End If

End Sub

Sub Form_Load ()

  Screen.MousePointer = HOURGLASS
  Remove_Items_From_SysMenu AppOpenSave
  Place_DialogBox_in_Form AppOpenSave, AppMain

  UpdateDirList = True     ' Update Drive/Subdirectory listbox first time
  SetFileLimit = True      ' Limit text length of file name first time
  
  '
  ' load dialog box caption
  '
  If App_OpenSaveStyle = APP_OPEN Then
    If App_OpenTitle = "" Then
      AppOpenSave.Caption = "File Open"
    Else
      AppOpenSave.Caption = App_OpenTitle
    End If
  Else
    If App_SaveTitle = "" Then
      AppOpenSave.Caption = "File Save As"
    Else
      AppOpenSave.Caption = App_SaveTitle
    End If
  End If
  App_OpenSaveTitle = AppOpenSave.Caption
  '
  ' load the path
  '
  If App_Path <> "" Then
    If Right$(App_Path, 1) = "\" Then
      App_Path = Left$(App_Path, (Len(App_Path) - 1))
      If Right$(App_Path, 1) = ":" Then App_Path = App_Path + "\"
    End If
    FilesList.Path = App_Path
  Else
    App_Path = FilesList.Path
  End If
  '
  ' set the pattern
  '
  If App_FileExtension <> "" Then
    FilesList.Pattern = "*" + App_FileExtension
  End If
  '
  ' load default file name
  '
  If App_OpenSaveStyle = APP_OPEN Then
    FileName.Text = FilesList.Pattern
  Else
    FileName.Text = App_FileName
  End If
  App_Drive = Left$(FilesList.Path, 2)
  Directory.Caption = FilesList.Path
  '
  ' adjust the dialog's controls for open or save
  '
  If App_OpenSaveStyle = APP_OPEN Then
    FilesLbl.Visible = True
    FilesLbl.Left = 165
    FilesList.Visible = True
    FilesList.Left = 165
    DirectoriesList.Left = 1950
    DirectoriesLbl.Left = 1950
  Else
    FilesLbl.Visible = False
    FilesList.Visible = False
    DirectoriesList.Left = 165
    DirectoriesLbl.Left = 165
  End If
  Screen.MousePointer = DEFAULT

End Sub

Sub OKCmd_Click ()
  Select Case LastChange
    
    Case 1
      FileName_KeyPress (13)

    Case 2
      App_Path = FilesList.Path
      App_FileName = FilesList.FileName
      If InStr(App_FileName, ".") = 0 Then App_FileName = App_FileName + "."
      App_FullFileName = Left$(BuildSpec((FilesList.Path)), Len(BuildSpec((FilesList.Path))) - 3) + FilesList.FileName
      App_DialogReturn = IDOK
      AppOpenSave.Hide

    Case 3
      DirectoriesList_Dblclick

    Case 4
      AppOpenSave.Hide

    Case 5
      App_Path = FilesList.Path
      App_FullFileName = Left$(BuildSpec((FilesList.Path)), Len(BuildSpec((FilesList.Path))) - 3) + App_FileName
      App_DialogReturn = IDOK
      AppOpenSave.Hide
    
    Case Else
    End Select

End Sub

Sub RefreshDirectoriesList ()
      
  Directory.Caption = FilesList.Path
  DirectoriesList.SetFocus
  CurFocus = GetFocus()
  Y& = SendMessage(CurFocus, LB_RESETCONTENT, 0, ByVal "")
  x& = SendMessage(CurFocus, LB_DIR, &HC010, ByVal BuildSpec((FilesList.Path)))
  ChDir FilesList.Path

End Sub

Function RemoveSpaces (TheText$) As String
  
  t$ = TheText$
  i% = 1
  Do
    i% = InStr(i%, t$, " ")
    If i% = 0 Then Exit Do
    t$ = Left$(t$, i% - 1) + Mid$(t$, i% + 1)
  Loop
  RemoveSpaces = t$

End Function

Function Validate_OpenFileName (fn As String, fqual As String) As Integer
  
  Dim temp As String
  Dim pqual As String
  Dim OldPath As String
  Dim FileNotFound As Integer
  Dim FirstCheck As Integer

  On Error GoTo OpenFileNameError
  
  Validate_OpenFileName = False
  OldPath = FilesList.Path

  SplitFileName fn, pqual, fqual
  '
  ' first assign any path change entered
  '
  If pqual <> "" Then FilesList.Path = pqual
  '
  ' now check the the file name
  '
  ' if it exists already a dblclick will be generated in
  ' the files list control otherwise a file error will be
  ' generated (i.e. file not found, bad file name )
  '
  FileNotFound = False
  FirstCheck = True
  FilesList.FileName = "*."
  FilesList.FileName = fqual
  If FileNotFound Then
    FirstCheck = False
    FilesList.FileName = "*."
    fqual = fqual + App_FileExtension
    FilesList.FileName = fqual
  Else
    If AppOpenSave.Visible Then
      '
      ' must have been a directory or pattern change only so update dir. list
      '
      RefreshDirectoriesList
      If InStr(fqual, "*") = 0 And InStr(fqual, "?") = 0 Then
	FilesList.Pattern = "*" + App_FileExtension
      End If
      FileName.Text = FilesList.Pattern
      FileName.SelStart = 0
      FileName.SelLength = 0
      FileName.SetFocus
    End If
  End If

Exit_OpenFunction:
  On Error GoTo 0
  Exit Function

OpenFileNameError:
  f$ = FilesList.Path
  If Right$(f$, 1) <> "\" Then f$ = f$ + "\"
  f$ = f$ + fqual
  Select Case Err
    Case FILE_NOT_FOUND
      If FirstCheck And InStr(fqual, ".") = 0 Then
	FileNotFound = True
	Resume Next
      End If
      e$ = "Cannot find " + UCase$(f$) + CRLF + CRLF + "check to ensure that the path and file are correct."
    Case PATH_NOT_FOUND
      e$ = "Directory does not exist;" + CRLF + CRLF + "check to ensure you specified the correct directory."
    Case Else
      e$ = Error$(Err) + ";" + CRLF + CRLF + "check to ensure the filename has no more than 8 characters followed by a period and a 3-letter extension." + CRLF + CRLF + "No spaces, commas, or backslashes (/) are allowed."
  End Select
  FilesList.Path = OldPath
  FilesList.Pattern = "*" + App_FileExtension
  Beep
  MsgBox e$, MB_ICONEXCLAMATION, APP_NAME
  Resume Exit_OpenFunction

End Function


Function Validate_SaveFileName (fn As String, fqual As String) As Integer
  
  Dim temp As String
  Dim pqual As String
  Dim OldPath As String

  On Error GoTo SaveFileNameError
  
  Validate_SaveFileName = False
  OldPath = FilesList.Path

  SplitFileName fn, pqual, fqual
  '
  ' first assign any path change entered
  '
  If pqual <> "" Then FilesList.Path = pqual
  
  '
  ' now check the the file name portion
  '
  If fqual <> "" Then
    If Not CheckFileQual(fqual) Then Error 64
    '
    ' if it exists already a dblclick will be generated in
    ' the files list control otherwise a file error will be
    ' generated (i.e. file not found, bad file name )
    '
    SaveDuplicate = False
    FilesList.FileName = "*."
    FilesList.FileName = fqual
    If SaveDuplicate Then Validate_SaveFileName = True
  Else
    '
    ' directory change
    '
    RefreshDirectoriesList
    FileName.Text = ""
    FileName.SetFocus
  End If

Exit_SaveFunction:
  On Error GoTo 0
  Exit Function

SaveFileNameError:
  If Err <> FILE_NOT_FOUND Then
    Beep
    Select Case Err
      Case PATH_NOT_FOUND
	e$ = "Directory does not exist;" + CRLF + CRLF + "check to ensure you specified the correct directory."
      Case Else
	e$ = Error$(Err) + ";" + CRLF + CRLF + "check to ensure the filename has no more than 8 characters followed by a period and a 3-letter extension." + CRLF + CRLF + "No spaces, commas, or backslashes (/) are allowed."
    End Select
    MsgBox e$, MB_ICONEXCLAMATION, APP_NAME
    FilesList.Path = OldPath
  Else
    Validate_SaveFileName = True
  End If
  Resume Exit_SaveFunction

End Function





